package pecas;

import java.awt.Graphics;
import javax.swing.ImageIcon;
import javax.swing.JPanel;

/**
 * 2014-06-10
 * @author Emerson Ribeiro de Mello
 */
public class Peca {

    private boolean cor; // true para preta, false para branca
    private int coluna;
    private int linha;
    private ImageIcon icone;

    public Peca(boolean c, int col, int lin) {
        this.coluna = col;
        this.linha = lin;
        this.cor = c;
        String corDaPeca = this.cor ? "rainha-p.png" : "rainha-b.png";
        this.icone = new ImageIcon(this.getClass().getResource("/resources/"+ corDaPeca));
    }

    public int getColuna() {
        return coluna;
    }

    public void setColuna(int coluna) {
        this.coluna = coluna;
    }

    public int getLinha() {
        return linha;
    }

    public void setLinha(int linha) {
        this.linha = linha;
    }

    public boolean isCor() {
        return cor;
    }


    /**
     * Diz se pode mover as pecas ou nao.
     *
     * @param linDestino - linha destino
     * @param colDestino - coluna destino
     * @param tabuleiro - Para ver qual peça está na casa destino e realizar a lógica do jogo
     * @return true - ok, pode mover.
     */
    public boolean mover(int linDestino, int colDestino, Peca[][] tabuleiro) {
        //dx = coluna e colDestino = linha
        System.out.println("lin: " + linha +", col: " + coluna);
        System.out.println("linD: " + linDestino +", colD: " + colDestino);
        
        // Uma lógica bem simples de movimentação, que serve só para exemplo
        if (tabuleiro[linDestino][colDestino] == null){
            tabuleiro[linDestino][colDestino] = this;
            tabuleiro[this.linha][this.coluna] = null;
            this.coluna = colDestino;
            this.linha = linDestino;
        }
        
        
       return true;
        

    }
    
    /**
     * Método para desenhar a peça no JPanel
     * @param g
     * @param ondeDesenhar 
     */
    public void desenhar (Graphics g, JPanel ondeDesenhar){
         g.drawImage(this.icone.getImage(), 10 + (50 * this.coluna), 10 + (50 * this.linha), ondeDesenhar);
    }
    
}
